﻿; The following is a bit of a hack -- the related FARR plugin's 
; OnInit method gets called even when FARR's "Plugins and Updates" 
; dialog box is displayed (not just when the plugin is initially 
; loaded).  The OnInit method starts Nea.exe, so if Nea.exe is 
; already running, don't want it to be started again.
#SingleInstance Ignore

; XXX: build script to package appropriate files and folders

SplitPath, A_ScriptName, , , , AppName
SetWorkingDir, % A_ScriptDir
IniName := AppName . ".ini"
IniPath := A_ScriptDir . "\" . IniName

; XXX: customizability via ini?
KeySequence := "^+Space"

; functions

FindSomethingRelevant()
{
  WinGetTitle, WinTitle, A
  ; XXX: handling of windows from which paths are not determined...
  If (!(WinTitle ~= "i)^[A-Z]:\\"))
  {
    MsgBox, % "Sorry, failed to determine path.`n`n"
            . "Path is determined via the title bar."
    SoundBeep
    Return
  }
  OutputDebug, % "WinGetTitle found: " . WinTitle
  WinGet, ProcessName, ProcessName, A
  OutputDebug, % "ProcessName: " . ProcessName
  If (ProcessName == "Notepad++.exe")
  {
    Position := InStr(WinTitle, " - Notepad++", true, 0)
    If (Position == 0)
    {
      OutputDebug, % "Strange...did not find - Notepad++ string"
    }
    Else
    {
      TargetPath := SubStr(WinTitle, 1, Position - 1)
      OutputDebug, % "SubStr result is: " . TargetPath
    }
  }
  Else
  {
    TargetPath := WinTitle
  }
  OutputDebug, % "Target path: " . TargetPath
  Return TargetPath
}

; main

Hotkey, % KeySequence, HotkeyHandler

Return

; subroutines

HotkeyHandler:
{
  OutputDebug, % "HotkeyHandler"
  ; pick something :)
  WhatToLoad := FindSomethingRelevant()
  OutputDebug, % "Found: " . WhatToLoad
  ; bring up qatapult
  Send +{Space}
  WinWaitActive, % "ahk_class Static"
  If (ErrorLevel == 1)
  {
    OutputDebug, % "WinWaitActive timed out"
    Return
  }
  ;Sleep, 200
  ClipSaved := ClipboardALl
  Clipboard := WhatToLoad
  Send ^v
  Clipboard := ClipSaved
  ClipSaved := ""
  ;Send {Tab}
  Return
}

ExitHandler:
{
  OutputDebug, % "Exiting app"
  ExitApp
}